<?php
/**
 * The template for displaying 404 pages (not found)
 *
 * @link https://codex.wordpress.org/Creating_an_Error_404_Page
 *
 * @package nesiapress
 */

get_header();
?>

	<main id="primary" class="site-main">
		<div class="np-container">
			
			<header class="page-header">
				
				<div class="np-page-gravatar">
					<span class="sr-only"><?php the_author(); ?></span>
					<?php echo get_avatar( get_the_author_meta( 'ID' ), 40 ); ?>
				</div> <!-- .np-page-gravatar -->
				
				<?php the_archive_title( '<h1 class="page-title">', '</h1>' ); ?>

				<div class="page-description">
					<p class="np-author-page-description"><?php the_author_meta('description') ?></p>
					<div class="np-author-page-info">
						<span class="np-hide">
							Join since: <?php echo the_author_meta('user_registered', 1 ); ?>
						</span>
						<span class="np-hide" aria-hidden="true"> &middot; </span>
						<span>
							<?php printf( 'Article Posted: %1$s ', count_user_posts( get_the_author_meta('ID') ) ); ?>
						</span>
					</div>
				</div> <!-- page-description -->
			</header><!-- .page-header -->

			<div class="np-grid-entries">
				<?php if ( have_posts() ) : ?>

					<?php
					/* Start the Loop */
					while ( have_posts() ) :
						the_post();

						/*
						* Include the Post-Type-specific template for the content.
						* If you want to override this in a child theme, then include a file
						* called content-___.php (where ___ is the Post Type name) and that will be used instead.
						*/
						get_template_part( 'template-parts/content', get_post_type() );

					endwhile;

					else :

					get_template_part( 'template-parts/content', 'none' );

				endif;
				?>
			</div><!-- .np-grid-entries -->
		</div><!-- .np-container -->
	</main><!-- #main -->

<?php
get_footer();
