<?php
/**
 * The template for displaying the footer
 *
 * Contains the closing of the #content div and all content after.
 *
 * @link https://developer.wordpress.org/themes/basics/template-files/#template-partials
 *
 * @package nesiapress
 */

?>

	<footer id="colophon" class="site-footer">
		<div class="np-container">
			<nav class="footer-nav-menu">
			<?php
				wp_nav_menu(
					array(
						'theme_location' => 'footer',
						'menu_id'        => 'footer-menu',
					)
				);
			?>
			</nav>
			<div class="site-info">
				<a class="wp-site" href="<?php echo esc_url( __( 'https://wordpress.org/', 'nesiapress' ) ); ?>">
					<?php
					/* translators: %s: CMS name, i.e. WordPress. */
					printf( esc_html__( 'Proudly powered by %s', 'nesiapress' ), 'WordPress' );
					?>
				</a>
				<span class="sep"> | </span>
					<?php
					/* translators: 1: Theme name, 2: Theme author. */
					printf( esc_html__( 'Theme: %1$s by %2$s.', 'nesiapress' ), 'NesiaPress', '<a class="np-site" href="https://nesiapress.com/">NesiaPress</a>' );
					?>
			</div><!-- .site-info -->
		</div><!-- .np-container -->
	</footer><!-- #colophon -->
</div><!-- #page -->

<?php wp_footer(); ?>

</body>
</html>
